unit fMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Mask, Buttons, ComCtrls, ExtCtrls, Spin, IniFiles, Math,
  cSPort;

const
  IniFileName = 'serIO.ini';
  cHexUvodniZnak = #$B6;

type
  TMainForm = class(TForm)
    btnTransmit: TButton;
    btnReceive: TButton;
    cbPort: TComboBox;
    cbBaudRate: TComboBox;
    cbParity: TComboBox;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    cbByteSize: TComboBox;
    cbStopBits: TComboBox;
    GroupBox1: TGroupBox;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    edtReceivString: TEdit;
    edtReceivHex: TEdit;
    btnF0: TSpeedButton;
    btnF1: TSpeedButton;
    btnF2: TSpeedButton;
    btnF3: TSpeedButton;
    btnF4: TSpeedButton;
    btnF5: TSpeedButton;
    btnF6: TSpeedButton;
    btnF7: TSpeedButton;
    btnF8: TSpeedButton;
    btnF9: TSpeedButton;
    MainMenu1: TMainMenu;
    Serialport1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Transmit1: TMenuItem;
    Receive1: TMenuItem;
    About1: TMenuItem;
    Functions1: TMenuItem;
    Define1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N41: TMenuItem;
    N51: TMenuItem;
    N61: TMenuItem;
    N71: TMenuItem;
    N81: TMenuItem;
    N91: TMenuItem;
    N01: TMenuItem;
    Bevel1: TBevel;
    StaticText8: TStaticText;
    cbRTSUsed: TComboBox;
    GroupBox2: TGroupBox;
    edtTransmitString: TEdit;
    edtTransmitHex: TEdit;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnTransmitClick(Sender: TObject);
    procedure btnReceiveClick(Sender: TObject);
    procedure ComboBoxChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure btnFunctionClick(Sender: TObject);
    procedure Define1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure edtTransmitStringChange(Sender: TObject);
    procedure edtTransmitHexChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    Changing: Boolean;
    SerialPort: TSerialPort;
    Buffer: array[0..1024] of byte;
    Delka: cardinal;
    ReceivedPacket: string;
    ToTransmit: string;
    procedure ReadIniFile;
    procedure WriteIniFile;
  public
    ShowReceiveError: Boolean;
    Functions: array[0..9] of string;
    function TransmitPacket(var Str: string): Boolean;
    function ReceivePacket(var Str: string): Boolean;
  end;

function HexToInt(const znak: char): byte;
  //  pevede znak 0-9, A-F na odpovdajc hexa hodnotu
function StrToHex(const co: string): string;
  //  pevede etzec nap. '0123' na hexa: 01 23
function HexaToInt(const Retezec: string): Integer;
  //  pevede etzec se znaky 0-9, A-F na integer
function HexToStr(const str1: string): string;
  //  pevede etzec s hexa znaky na ASCII znaky (opan fce k StrToHex)
function HexDToInt(const co: byte): byte; //  pevede $11 na deg 11
function IntToHexD(const co: byte): byte; //  opan k HexDToInt

function HexToStr2(const str1: string): string;
function ToFilteredString2(const Str: string): string;

function ToFilteredString(const Str: string): string;
function FromFilteredString(const Str: string): string;

var
  MainForm: TMainForm;

implementation

uses fDefine, fAbout, fAuto;

{$R *.DFM}

function HexToInt(const znak: char): byte;
const
  HexaSoustava: array[0..15] of char = ('0', '1', '2', '3', '4', '5', '6', '7',
    '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
begin
  Result := Pos(UpCase(znak), HexaSoustava) - 1;
end;

function StrToHex(const co: string): string;
var
  i: integer;
begin
  result := '';
  for i := 1 to Length(co) div 2 do
    result := result + Chr(HexToInt(co[i * 2 - 1]) * $10 + HexToInt(co[i * 2]));
end;

function HexaToInt(const Retezec: string): Integer;
const
  HexaSoustava: array[0..15] of char = ('0', '1', '2', '3', '4', '5', '6', '7',
    '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
var
  i: integer;
begin
  Result := 0;
  for i := 1 to Length(Retezec) do
    Result := Result + Trunc(Power(16, i - 1)
      * (Pos(Retezec[Length(Retezec) - i + 1], HexaSoustava) - 1));
end;

function HexToStr(const str1: string): string;
var
  Str2: string;
  i: Integer;
begin
  Str2 := '';
  for i := 1 to Length(str1) do
    Str2 := Str2 + IntToHex(Ord(Str1[i]), 2);
  Result := Str2;
end;

function HexDToInt(const co: byte): byte;
begin
  Result := (co div $10) * 10 + co mod $10;
end;

function IntToHexD(const co: byte): byte;
begin
  Result := (co div 10) * $10 + co mod 10;
end;





function HexToStr2(const str1: string): string;
var
  Str2: string;
  i: Integer;
begin
  Str2 := '';
  for i := 1 to Length(str1) do
    Str2 := Str2 + IntToHex(Ord(Str1[i]), 2) + ' ';
  Result := Str2;
end;

function ToFilteredString2(const Str: string): string;
var
  Pom: string;
  i: integer;
begin
  Pom := '';
  for i := 1 to Length(Str) do
  begin
    if (Ord(Str[i]) < $20) or (Ord(Str[i]) >= $AE) then
      Pom := Pom + cHexUvodniZnak + IntToHex(Ord(Str[i]), 2) + ' '
    else
      Pom := Pom + Str[i] + ' ';
  end;
  Result := Pom;
end;










function ToFilteredString(const Str: string): string;
var
  Pom: string;
  i: integer;
begin
  Pom := '';
  for i := 1 to Length(Str) do
  begin
    if (Ord(Str[i]) < $20) or (Ord(Str[i]) >= $AE) then
      Pom := Pom + cHexUvodniZnak + IntToHex(Ord(Str[i]), 2)
    else
      Pom := Pom + Str[i];
  end;
  Result := Pom;
end;

function FromFilteredString(const Str: string): string;
var
  Pom: string;
  i: integer;
begin
  i := 1;
  Pom := '';
  while i <= Length(Str) do
  begin
    if Str[i] = cHexUvodniZnak then
    begin
      Pom := Pom + StrToHex(Copy(Str, i + 1, 2));
      Inc(i, 2);
    end
    else
      Pom := Pom + Str[i];

    Inc(i);
  end;
  Result := Pom;
end;











function TMainForm.TransmitPacket(var Str: string): Boolean;
var
  i: integer;
begin
  Result := False;

  for i := 1 to Length(Str) do
    Buffer[i - 1] := Ord(Str[i]);
  Delka := Length(Str);

  if not SerialPort.Transmit(Buffer, Delka) then
  begin
    MessageDlg('Chyba odesln paketu!', mtError, [mbOK], 0);
    Exit;
  end;

  Result := True;
end;

function TMainForm.ReceivePacket(var Str: string): Boolean;
var
  i: integer;
begin
  Result := False;
  if not SerialPort.Receive(Buffer, Delka) then
  begin
    if ShowReceiveError then
      MessageDlg('Chyba pjmn paketu!', mtError, [mbOk], 0);
    Exit;
  end;

  Str := '';
  for i := 0 to Delka - 1 do
    Str := Str + Chr(Buffer[i]);

  Result := True;
end;

procedure TMainForm.ReadIniFile;
var
  IniFile: TIniFile;
  Dir: string;
  i: integer;
begin
  GetDir(0, Dir);
  if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';
  IniFile := TIniFile.Create(Dir + IniFileName);

  cbPort.ItemIndex := cbPort.Items.IndexOf(IniFile.ReadString('PortSettings',
    'COM', 'COM1'));
  cbBaudRate.ItemIndex :=
    cbBaudRate.Items.IndexOf(IniFile.ReadString('PortSettings', 'BaudRate',
    '9600'));
  cbParity.ItemIndex :=
    cbParity.Items.IndexOf(IniFile.ReadString('PortSettings',
    'Parity', 'no'));
  cbByteSize.ItemIndex :=
    cbByteSize.Items.IndexOf(IniFile.ReadString('PortSettings', 'ByteSize',
    '8'));
  cbStopBits.ItemIndex :=
    cbStopBits.Items.IndexOf(IniFile.ReadString('PortSettings', 'StopBits',
    '1'));
  cbRTSUsed.ItemIndex := IniFile.ReadInteger('PortSettings', 'RTSUsed', 0);

  for i := 0 to 9 do
    Functions[i] := StrToHex(IniFile.ReadString('Functions', Chr($30 + i), ''));

  IniFile.Free;
end;

procedure TMainForm.WriteIniFile;
var
  IniFile: TIniFile;
  Dir: string;
  i: integer;
begin
  GetDir(0, Dir);
  if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';

  try
    IniFile := TIniFile.Create(Dir + IniFileName);

    IniFile.WriteString('PortSettings', 'COM', cbPort.Text);
    IniFile.WriteString('PortSettings', 'BaudRate', cbBaudRate.Text);
    IniFile.WriteString('PortSettings', 'Parity', cbParity.Text);
    IniFile.WriteString('PortSettings', 'ByteSize', cbByteSize.Text);
    IniFile.WriteString('PortSettings', 'StopBits', cbStopBits.Text);
    IniFile.WriteInteger('PortSettings', 'RTSUsed', cbRTSUsed.ItemIndex);

    for i := 0 to 9 do
      IniFile.WriteString('Functions', Chr($30 + i), HexToStr(Functions[i]));

    IniFile.Free;
  except
    MessageDlg('Error writing configuration file!!', mtError, [mbOk], 0);
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ShowReceiveError := True;
  ToTransmit := '';
  ReadIniFile;
  ComboBoxChange(Self);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SerialPort.Free;
  WriteIniFile;
end;

procedure TMainForm.btnTransmitClick(Sender: TObject);
begin
  if Length(ToTransmit) = 0 then
    MessageDlg('No data!', mtError, [mbOk], 0)
  else
    TransmitPacket(ToTransmit);
end;

procedure TMainForm.btnReceiveClick(Sender: TObject);
begin
  if ReceivePacket(ReceivedPacket) then
  begin
    edtReceivString.Text := ToFilteredString(ReceivedPacket);
    edtReceivHex.Text := HexToStr(ReceivedPacket);
  end;
end;

procedure TMainForm.ComboBoxChange(Sender: TObject);
begin
  SerialPort.Free;
  SerialPort := TSerialPort.Create(cbPort.Text, StrToInt(cbBaudRate.Text),
    cbParity.ItemIndex, cbByteSize.ItemIndex + 4, cbStopBits.ItemIndex,
    TRTSUsed(cbRTSUsed.ItemIndex));
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.btnFunctionClick(Sender: TObject);
var
  fnNum: integer;
begin
  fnNum := (Sender as TComponent).Tag;
  ToTransmit := Functions[fnNum];
  edtTransmitString.Text := ToFilteredString(ToTransmit);
end;

procedure TMainForm.Define1Click(Sender: TObject);
begin
  DefinovaniFunkciForm.ShowModal;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.edtTransmitStringChange(Sender: TObject);
begin
  if not Changing then
  begin
    Changing := True;
    ToTransmit := FromFilteredString(edtTransmitString.Text);
    edtTransmitHex.Text := HexToStr(ToTransmit);
    Changing := False;
  end;
end;

procedure TMainForm.edtTransmitHexChange(Sender: TObject);
begin
  if not Changing then
  begin
    Changing := True;
    ToTransmit := StrToHex(edtTransmitHex.Text);
    edtTransmitString.Text := ToFilteredString(ToTransmit);
    Changing := False;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  AutoReceiveForm.ShowModal;
end;

end.

